package OMAPI::HREC;
    use strict;
    1;

our $SCHEMA = {
    'handle'			=> 'H'
,   'name'			=> 'S'
,   'dhcp-client-identifier'	=> 'D'
,   'hardware-address'		=> 'D'
,   'hardware-type'		=> 'I'
,   'ip-address'		=> 'D'
};

our $ORDER = [qw (ip-address state dhcp-client-identifier client-hostname 
	subnet pool hardware-address hardware-type starts ends tstp tsfp
	cltt)];


#=============================================================================
#
sub TIEHASH {
    my ($package, $handle) = @_;

    my $basis = bless ({
        'LEASE'		=> $handle
    }, $package);

    return $basis;
}


#=============================================================================
#
sub FETCH {
    my ($basis, $key) = @_;
    my ($type);

    unless (defined ($type = $SCHEMA->{$key})) {
        return undef;
    } 

    my $value = OMAPI::CORE::Get_Value ($basis->{'LEASE'}, $key, $type);
    return $value;
}


#=============================================================================
#
sub STORE {
    my ($basis, $key, $value) = @_;
    my ($type);

    unless (defined ($type = $SCHEMA->{$key})) {
        return undef;
    } 

    OMAPI::CORE::Set_Value ($basis->{'LEASE'}, $key, $type, $value);
    return $value;
}


#=============================================================================
#
sub FIRSTKEY {
    my ($basis) = @_;

    $basis->{'KEY-LIST'} = [keys %$SCHEMA];
    return shift @{$basis->{'KEY-LIST'}};
}


#=============================================================================
#
sub NEXTKEY {
    my ($basis, $last_key) = @_;

    return shift @{$basis->{'KEY-LIST'}};
}
