package OMAPI::LREC;
    use strict;
    1;

our $SCHEMA = {
    'ip-address'		=> 'D'
,   'state'			=> 'H'
,   'dhcp-client-identifier'	=> 'D'
,   'client-hostname'		=> 'S'
,   'host'			=> 'H'
,   'subnet'			=> 'H'
,   'pool'			=> 'H'
,   'hardware-address'		=> 'D'
,   'hardware-type'		=> 'I'
,   'starts'			=> 'T'
,   'ends'			=> 'T'
,   'tstp'			=> 'I'
,   'tsfp'			=> 'I'
,   'cltt'			=> 'I'
};


#=============================================================================
#
sub TIEHASH {
    my ($package, $handle) = @_;

    my $basis = bless ({
        'LEASE'		=> $handle
    }, $package);

    return $basis;
}


#=============================================================================
#
sub FETCH {
    my ($basis, $key) = @_;
    my ($type);

    unless (defined ($type = $SCHEMA->{$key})) {
        return undef;
    } 

    my $value = OMAPI::CORE::Get_Value ($basis->{'LEASE'}, $key, $type);
    return $value;
}


#=============================================================================
#
sub STORE {
    my ($basis, $key, $value) = @_;
    my ($type);

    unless (defined ($type = $SCHEMA->{$key})) {
        return undef;
    } 

    OMAPI::CORE::Set_Value ($basis->{'LEASE'}, $key, $type, $value);
    return $value;
}


#=============================================================================
#
sub FIRSTKEY {
    my ($basis) = @_;

    $basis->{'KEY-LIST'} = [keys %$SCHEMA];

    return shift @{$basis->{'KEY-LIST'}};
}


#=============================================================================
#
sub NEXTKEY {
    my ($basis, $last_key) = @_;

    return shift @{$basis->{'KEY-LIST'}};
}
